//XSETASETA@GMAIL.COM
//SETA43
// 15/06/2018
// 29/05/2023  SDL2
//

#include "agrafi.h"



void refresco(void)
{ 
#ifdef SDL2
    SDL_UpdateWindowSurface(window);
#else
    SDL_Flip(screen);
#endif
}

void cls(int r,int g,int b)
{
    SDL_FillRect(screen, 0, SDL_MapRGB(screen->format,r,g,b));
}

void screenFull(char fullScreen)
{ 
  if(fullScreen) 
    {
     #ifdef SDL2
        SDL_SetWindowFullscreen(window, SDL_WINDOW_FULLSCREEN);  screen = SDL_GetWindowSurface(window); 
     #else
         #if YesWindows
                screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_FULLSCREEN | SDL_SWSURFACE );
         #else
                SDL_WM_ToggleFullScreen(screen);
         #endif
     #endif
    }
    else 
    {
     #ifdef SDL2
        SDL_SetWindowFullscreen(window, 0);  screen = SDL_GetWindowSurface(window); 
     #else
        screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
     #endif
    }
}
//_____________________________________________


int init(int ancho,int alto)
{
    SCREEN_WIDTH = ancho; 
	SCREEN_HEIGHT = alto;

#ifdef SDL2
    if( SDL_Init(SDL_INIT_VIDEO) == -1 )  return 0;
    window = SDL_CreateWindow("SDL2", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, ancho, alto, 0);
    if (window == NULL) 	{	printf("Window could not be created:\n");	return 1;	}
    
    renderer = SDL_CreateRenderer(window, -1, 0);
    screen = SDL_GetWindowSurface(window);

    
    printf("Profundidad bit=%d  byte=%d\n",screen->format->BitsPerPixel,screen->format->BytesPerPixel);
    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) { printf("ERROR TTF_Init: \n"); return 0; }
		//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}
#else
      if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )  return 0;
 //   screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
	printf("Profundidad bit=%d  byte=%d\n",screen->format->BitsPerPixel,screen->format->BytesPerPixel);
    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) 
		{
    	 printf("TTF_Init: %s\n", TTF_GetError());
   		 return 0;
		}

		//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}
#endif
    return(1);
}

int load_files(char *f_fondo,char *f_imagenes,char *f_font)
{	
    SDL_Surface *temp1, *temp2, *temp3;
	if(f_fondo!=NULL)
		{
			background = load_image( (char*) f_fondo );
			if( background == NULL )  return 0;
		}
	if(f_imagenes!=NULL)
		{
			dots = load_image( (char*) f_imagenes );
#ifdef SDL2            
            texture = SDL_CreateTextureFromSurface( renderer, dots );
#else
			if( dots == NULL )  return 0;
#endif
		}
	if(f_font!=NULL)
		{
			font = TTF_OpenFont( (char*) f_font, 20 );
			if( font == NULL ) { printf("Error cargando Font\n"); return 0;	}	
		}
	
	return 1;
}



void clean_up()
{
	if(SONIDO)Mix_FreeChunk(sonido);
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}



SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){ printf("Error al cargar %s\n", filename); return 0;	}
    	
    //if(window == NULL) return temp;
    
#ifdef SDL2            
    ima = SDL_ConvertSurfaceFormat(temp, SDL_GetWindowPixelFormat(window), 0);
    SDL_FreeSurface(temp);
    if( ima != NULL )
        {
            SDL_SetColorKey( ima, SDL_TRUE, SDL_MapRGB( ima->format, 0, 0xFF, 0xFF ) );
			#ifdef DEBUG
				printf("ok al cargar %s\n", filename);
			#endif
        }
#else
    	ima = SDL_DisplayFormat(temp);
		SDL_FreeSurface( temp );
        if( ima != NULL )
        {
            SDL_SetColorKey( ima, SDL_SRCCOLORKEY, SDL_MapRGB( ima->format, 0, 0xFF, 0xFF ) );
			#ifdef DEBUG
				printf("ok al cargar %s\n", filename);
			#endif
        }
#endif

	
	return ima; 
}

void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}


//_________________PRIMITIVAS

void setcolor(unsigned char r,unsigned char g,unsigned char b)
{
	ColorDefault.r=r;	ColorDefault.g=g;	ColorDefault.b=b;
}

void plot(int x,int y) {putpixel(x,y,ColorDefault);}


/* ----- Imprime cuadrado ----- */
void box(int x,int y,int xx,int yy)
{
	//setcolor();
	if(x<0) x=0;
	if(xx<0) xx=0;
	if(y<0) y=0;
	if(yy<0) yy=0;
	line(x,y,xx,y);
	line(xx,y,xx,yy);
	line(xx,yy,x,yy);
	line(x,yy,x,y);
}


/* ----- Imprime cuadrado relleno----- */
void bar(int x,int y,int xx,int yy)
{
int  d,d2; 
unsigned  int c,cc,z,z1,zz,tt;
int Walto=screen->h;
int Wancho=screen->w;

	if(x>xx){d=x; x=xx; xx=d;}
  	if(y>yy){d=y; y=yy; yy=d;}
//	setcolor();

       if(x<0)x=0;
       if(xx<0)xx=0;
       if(y<0)y=0;
       if(yy<0)yy=0;
       if(x>=Wancho)x=Wancho-1;
       if(xx>=Wancho)xx=Wancho-1;
       if(y>=Walto)y=Walto-1;
       if(yy>=Walto)yy=Walto-1;
       for(zz=y;zz<yy;zz++) line(x,zz,xx,zz);
}



/* ----- IMPRIME LINEA ------------ */
void line(int x,int y,int xx,int yy)
{
 unsigned short int z,c,a,vx,vy;
 int Walto=screen->h;
 int Wancho=screen->w;

                 if(x==xx)
	                {
                         if(y>yy){z=y;y=yy;yy=z;}
                         if(y<0) y=0;
                         if(yy>Walto)yy=Walto;
                         for(;y<=yy;y++)plot(x,y);
                         goto fin;
                        }

                 if(y==yy)
                    	{
                         if(x>xx){z=x;x=xx;xx=z;}
                         if(x<0)x=0;
                         if(xx>Wancho)xx=Wancho;
                         for(;x<=xx;x++)plot(x,y);
                         goto fin;
                        }                       
                 if(x<xx)
					{
                    if(y<yy)
                     goto normal;
                    else
                     goto nonormal;
                    }
                    else
                    {
                    if(y>yy)
                       {    z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto normal;  }
                       else
                       {    z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto nonormal;  }
                    }
nonormal:
   		 vx=xx-x; vy=y-yy;a=0;
                 plot(xx,yy);
                 if(vx>vy)
                   {
                    c=vx;
                    while(c>0)
						{
							c--;xx--;a+=vy;
							if(a>=vx){a-=vx; yy++;}
							plot(xx,yy);
						}
                   }
                     else
                   {
                    c=vy;
                    while(c>0)
						{
							c--;yy++;a+=vx;
							if(a>=vy){a-=vy;xx--;}
							plot(xx,yy);
						}
                   }
                 goto fin;
normal:
   		 vx=xx-x;vy=yy-y;a=0;
                 plot(x,y);
                 if(vx>vy)
                 {
                  c=vx;
                  while(c>0)
						{
							c--; x++; a=a+vy;
							if(a>=vx){ a-=vx; y++; }
							plot(x,y);
						}
                 }
				else
                 {
                  c=vy;
                  while(c>0)
                     {
						c--; y++; a=a+vx;
						if(a>=vy){ a-=vy; x++; }
						plot(x,y);
                     }
                 }
	fin:
	;
}



void putpixel(int x,int y,SDL_Color color)
{	
	unsigned int col=SDL_MapRGB(screen->format,color.r,color.g,color.b);	
	char *buffer=(char*) screen->pixels;
	buffer+=screen->pitch*y;
	buffer+=screen->format->BytesPerPixel*x;
	char *direccolor=(char*) &col;
	switch (screen->format->BytesPerPixel)			
			{	
				case 4:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;	
				case 3:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;						
				case 2:
					*(buffer++)=*(direccolor++);
					*(buffer++)=*(direccolor++);
				break;
				case 1:
					*(buffer++)=*(direccolor++);
				break;				
			}
}	


unsigned int getpixel(int x,int y)
{
    //RGB,ALFA
    unsigned int col;
    unsigned char rojo,verde,azul,colorkey;	
	char *buffer=(char*) screen->pixels;
	buffer+=screen->pitch*y;
	buffer+=screen->format->BytesPerPixel*x;
	switch (screen->format->BytesPerPixel)
			{	
				case 4:
					rojo=*(buffer++);
					verde=*(buffer++);
					azul=*(buffer++);
					colorkey=*(buffer++);
                    col= (int) rojo<<24 | (int) verde<<16 | (int) azul<<8 | (int) colorkey;
				break;	
				case 3:
					rojo=*(buffer++);
					verde=*(buffer++);
					azul=*(buffer++);
                    col= (int) rojo<<16 | (int) verde<<8 | (int) azul;
				break;
				case 2:
					rojo=*(buffer++);
					verde=*(buffer++);
                    col= (int) rojo<<8 | (int) verde;
				break;
				case 1:
					rojo=*(buffer++);
                    col=rojo;
				break;				
			}
  return(col);  
}







/*
 * Return the pixel value at (x, y)
 * NOTE: The surface must be locked before calling this!
 */
Uint32 getpixel2(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) 
    {
		case 1:
			return *p;

		case 2:
			return *(Uint16 *)p;

		case 3:
			if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
				return p[0] << 16 | p[1] << 8 | p[2];
			else
				return p[0] | p[1] << 8 | p[2] << 16;

		case 4:
			return *(Uint32 *)p;

		default:
			return 0;       /* shouldn't happen, but avoids warnings */
    }
}


/* ----- BUSCA COLOR EN LINEA ------------ */
bool getline(int x,int y,int xx,int yy,unsigned int color)
{
 unsigned short int z;
 int Walto=screen->h;
 int Wancho=screen->w;

                 if(x==xx)
	                {
                         if(y>yy){z=y;y=yy;yy=z;}
                         if(y<0) y=0;
                         if(yy>Walto)yy=Walto;
                         for(;y<=yy;y++) if(color==getpixel(x,y)) return(1);
                         goto fin;
                        }

                 if(y==yy)
                    	{
                         if(x>xx){z=x;x=xx;xx=z;}
                         if(x<0)x=0;
                         if(xx>Wancho)xx=Wancho;
                         for(;x<=xx;x++)if(color==getpixel(x,y)) return(1);
                         goto fin;
                        }                       
	fin:
	return(0);
}







